/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSDistributedLock;

import dstep.foundation.NSDate;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

class NSDistributedLock : NSObject
{
	mixin ObjcWrap;

	static NSDistributedLock lockWithPath (NSString path)
	{
		return invokeObjcSelfClass!(NSDistributedLock, "lockWithPath:", NSString)(pathreturn result is this.objcObject ? this : (result !is null ? new NSDistributedLock(result) : null);	}

	Object initWithPath (NSString path)
	{
		return invokeObjcSelf!(Object, "initWithPath:", NSString)(path);
	}

	this (NSString path)
	{
		objcObject = Bridge.invokeObjcClassMethod!(id, "alloc")(objcClass);
		id result = Bridge.invokeObjcMethod!(id, "initWithPath:", NSString)(objcObject, path);

		if (result)
			objcObject = ret;

		dObject = this;
	}

	bool tryLock ()
	{
		return invokeObjcSelf!(bool, "tryLock");
	}

	void unlock ()
	{
		return invokeObjcSelf!(void, "unlock");
	}

	void breakLock ()
	{
		return invokeObjcSelf!(void, "breakLock");
	}

	NSDate lockDate ()
	{
		return invokeObjcSelf!(NSDate, "lockDate");
	}
}

