/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSGarbageCollector;

import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

class NSGarbageCollector : NSObject
{
	mixin ObjcWrap;

	static Object defaultCollector ()
	{
		return invokeObjcSelfClass!(Object, "defaultCollector");
	}

	bool isCollecting ()
	{
		return invokeObjcSelf!(bool, "isCollecting");
	}

	void disable ()
	{
		return invokeObjcSelf!(void, "disable");
	}

	void enable ()
	{
		return invokeObjcSelf!(void, "enable");
	}

	bool isEnabled ()
	{
		return invokeObjcSelf!(bool, "isEnabled");
	}

	void collectIfNeeded ()
	{
		return invokeObjcSelf!(void, "collectIfNeeded");
	}

	void collectExhaustively ()
	{
		return invokeObjcSelf!(void, "collectExhaustively");
	}

	void disableCollectorForPointer (void* ptr)
	{
		return invokeObjcSelf!(void, "disableCollectorForPointer:", void*)(ptr);
	}

	void enableCollectorForPointer (void* ptr)
	{
		return invokeObjcSelf!(void, "enableCollectorForPointer:", void*)(ptr);
	}

	NSZone* zone ()
	{
		return invokeObjcSelf!(NSZone*, "zone");
	}
}

