/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSProtocolChecker;

import dstep.foundation.NSObject;
import dstep.foundation.NSProxy;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

class NSProtocolChecker : NSProxy
{
	mixin ObjcWrap;
	mixin TNSProtocolCheckerCreation;

	Protocol protocol ()
	{
		return invokeObjcSelf!(Protocol, "protocol");
	}

	NSObject target ()
	{
		return invokeObjcSelf!(NSObject, "target");
	}
}

template TNSProtocolCheckerCreation ()
{
	static Object protocolCheckerWithTarget (NSObject anObject, Protocol aProtocol)
	{
		return invokeObjcSelfClass!(Object, "protocolCheckerWithTarget:protocol:", NSObject, Protocol)(anObject, aProtocol);
	}

	Object initWithTarget (NSObject anObject, Protocol aProtocol)
	{
		return invokeObjcSelf!(Object, "initWithTarget:protocol:", NSObject, Protocol)(anObject, aProtocol);
	}

	this (NSObject anObject, Protocol aProtocol)
	{
		objcObject = Bridge.invokeObjcClassMethod!(id, "alloc")(objcClass);
		id result = Bridge.invokeObjcMethod!(id, "initWithTarget:protocol:", NSObject, Protocol)(objcObject, anObject, aProtocol);

		if (result)
			objcObject = ret;

		dObject = this;
	}
}

