/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSValueTransformer;

import dstep.foundation.NSArray;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

import bindings = dstep.foundation.NSValueTransformer_bindings;

const NSString NSNegateBooleanTransformerName;
const NSString NSIsNilTransformerName;
const NSString NSIsNotNilTransformerName;
const NSString NSUnarchiveFromDataTransformerName;
const NSString NSKeyedUnarchiveFromDataTransformerName;

static this ()
{
	NSNegateBooleanTransformerName = new NSString(bindings.NSNegateBooleanTransformerName);
	NSIsNilTransformerName = new NSString(bindings.NSIsNilTransformerName);
	NSIsNotNilTransformerName = new NSString(bindings.NSIsNotNilTransformerName);
	NSUnarchiveFromDataTransformerName = new NSString(bindings.NSUnarchiveFromDataTransformerName);
	NSKeyedUnarchiveFromDataTransformerName = new NSString(bindings.NSKeyedUnarchiveFromDataTransformerName);
}

class NSValueTransformer : NSObject
{
	mixin ObjcWrap;

	static void setValueTransformer (NSValueTransformer transformer, NSString name)
	{
		return invokeObjcSelfClass!(void, "setValueTransformer:forName:", NSValueTransformer, NSString)(transformer, name);
	}

	static NSValueTransformer valueTransformerForName (NSString name)
	{
		return invokeObjcSelfClass!(NSValueTransformer, "valueTransformerForName:", NSString)(namereturn result is this.objcObject ? this : (result !is null ? new NSValueTransformer(result) : null);	}

	static NSArray valueTransformerNames ()
	{
		return invokeObjcSelfClass!(NSArray, "valueTransformerNames");
	}

	static Class transformedValueClass ()
	{
		return invokeObjcSelfClass!(Class, "transformedValueClass");
	}

	static bool allowsReverseTransformation ()
	{
		return invokeObjcSelfClass!(bool, "allowsReverseTransformation");
	}

	Object transformedValue (Object value)
	{
		return invokeObjcSelf!(Object, "transformedValue:", Object)(value);
	}

	Object reverseTransformedValue (Object value)
	{
		return invokeObjcSelf!(Object, "reverseTransformedValue:", Object)(value);
	}
}

